Botan: Botan::Hash_Filter Class Reference

Botan 1.10.16

Public Member Functions | Protected Member Functions | List of all members
Botan::Hash_Filter Class Reference

`#include <filters.h>`

Inheritance diagram for Botan::Hash_Filter:

## Public Member Functions
virtual bool | attachable ()
void | end_msg ()
| Hash_Filter (HashFunction *hash_fun, size_t len=0)
| Hash_Filter (const std::string &request, size_t len=0)
std::string | name () const
virtual void | start_msg ()
void | write (const byte input[], size_t len)
| ~Hash_Filter ()

## Protected Member Functions
void | send (const byte in[], size_t length)
void | send (byte in)
void | send (const MemoryRegion< byte > &in)
void | send (const MemoryRegion< byte > &in, size_t length)

## Detailed Description

Hash Filter.

Definition at line 104 of file filters.h.

## Constructor & Destructor Documentation

## ◆ Hash_Filter() [1/2]

Botan::Hash_Filter::Hash_Filter | ( | HashFunction * | hash_fun,
|  | size_t | len = `0`
| ) |  |
| inline

Construct a hash filter.

Parameters

  hash_fun | the hash function to use
  len | the output length of this filter. Leave the default value 0 if you want to use the full output of the hashfunction hash. Otherwise, specify a smaller value here so that the output of the hash algorithm will be cut off.

Definition at line 120 of file filters.h.

120 :
121 OUTPUT_LENGTH(len), hash(hash_fun) {}

## ◆ Hash_Filter() [2/2]

Botan::Hash_Filter::Hash_Filter | ( | const std::string & | request,
|  | size_t | len = `0`
| ) |  |

Construct a hash filter.

Parameters

  request | the name of the hash algorithm to use
  len | the output length of this filter. Leave the default value 0 if you want to use the full output of the hashfunction hash. Otherwise, specify a smaller value here so that the output of the hash algorithm will be cut off.

Definition at line 82 of file algo_filt.cpp.

References Botan::Library_State::algorithm_factory(), Botan::Global_State_Management::global_state(), and Botan::Algorithm_Factory::make_hash_function().

83 :
84 OUTPUT_LENGTH(len)
85 {
86 Algorithm_Factory& af = global_state().algorithm_factory();
87 hash = af.make_hash_function(algo_spec);
88 }
Botan::Library_State::algorithm_factory
Algorithm_Factory & algorithm_factory() const
Definition: libstate.cpp:173
Botan::Global_State_Management::global_state
Library_State & global_state()
Definition: global_state.cpp:32

## ◆ ~Hash_Filter()

Botan::Hash_Filter::~Hash_Filter | ( |  | ) |
| inline

Definition at line 133 of file filters.h.

133 { delete hash; }

## Member Function Documentation

## ◆ attachable()

virtual bool Botan::Filter::attachable | ( |  | ) |
| inlinevirtualinherited

Check whether this filter is an attachable filter.

Returns
  true if this filter is attachable, false otherwise

Reimplemented in Botan::SecureQueue, and Botan::DataSink.

Definition at line 50 of file filter.h.

50 { return true; }

## ◆ end_msg()

void Botan::Hash_Filter::end_msg | ( |  | ) |
| virtual

Notify that the current message is finished; flush buffers and do end-of-message processing (if any).

Reimplemented from Botan::Filter.

Definition at line 93 of file algo_filt.cpp.

References Botan::Buffered_Computation::final(), Botan::Filter::send(), and Botan::MemoryRegion< T >::size().

94 {
95 SecureVector<byte> output = hash->final();
96 if(OUTPUT_LENGTH)
97 send(output, std::min<size_t>(OUTPUT_LENGTH, output.size()));
98 else
99 send(output);
100 }
Botan::Filter::send
void send(const byte in[], size_t length)
Definition: filter.cpp:28
Botan::Buffered_Computation::final
void final(byte out[])
Definition: buf_comp.h:80

## ◆ name()

std::string Botan::Hash_Filter::name | ( |  | ) | const
| inlinevirtual

Returns
  descriptive name for this filter

Implements Botan::Filter.

Definition at line 110 of file filters.h.

110 { return hash->name(); }
Botan::Algorithm::name
virtual std::string name() const =0

## ◆ send() [1/4]

void Botan::Filter::send | ( | const byte | in[],
|  | size_t | length
| ) |  |
| protectedinherited

Parameters

  in | some input for the filter
  length | the length of in

Definition at line 28 of file filter.cpp.

References Botan::MemoryRegion< T >::clear(), Botan::Filter::end_msg(), Botan::MemoryRegion< T >::size(), Botan::Filter::start_msg(), and Botan::Filter::write().

Referenced by Botan::Base64_Encoder::Base64_Encoder(), Botan::EAX_Decryption::EAX_Decryption(), Botan::PK_Encryptor_Filter::end_msg(), Botan::Bzip_Compression::end_msg(), Botan::Zlib_Compression::end_msg(), Botan::PBE_PKCS5v15::end_msg(), Botan::Hex_Encoder::end_msg(), Botan::Base64_Encoder::end_msg(), Botan::PBE_PKCS5v20::end_msg(), Botan::PK_Decryptor_Filter::end_msg(), Botan::Bzip_Decompression::end_msg(), Botan::Zlib_Decompression::end_msg(), Botan::PK_Signer_Filter::end_msg(), Botan::Hex_Decoder::end_msg(), Botan::Base64_Decoder::end_msg(), Botan::PK_Verifier_Filter::end_msg(), end_msg(), Botan::MAC_Filter::end_msg(), Botan::Bzip_Compression::flush(), Botan::Zlib_Compression::flush(), Botan::Hex_Encoder::Hex_Encoder(), Botan::ECB_Encryption::name(), Botan::EAX_Base::name(), Botan::ECB_Decryption::name(), Botan::CTS_Encryption::set_iv(), Botan::CFB_Encryption::set_iv(), Botan::CBC_Encryption::set_iv(), Botan::CFB_Decryption::set_iv(), Botan::CTS_Decryption::set_iv(), Botan::CBC_Decryption::set_iv(), Botan::XTS_Encryption::set_key(), Botan::XTS_Decryption::set_key(), Botan::Bzip_Compression::write(), Botan::Zlib_Compression::write(), Botan::StreamCipher_Filter::write(), Botan::Bzip_Decompression::write(), Botan::Zlib_Decompression::write(), Botan::Hex_Decoder::write(), and Botan::Base64_Decoder::write().

29 {
30 bool nothing_attached = true;
31 for(size_t j = 0; j != total_ports(); ++j)
32 if(next[j])
33 {
34 if(write_queue.size())
35 next[j]->write(&write_queue[0], write_queue.size());
36 next[j]->write(input, length);
37 nothing_attached = false;
38 }
39
40 if(nothing_attached)
41 write_queue += std::make_pair(input, length);
42 else
43 write_queue.clear();
44 }
Botan::Filter::write
virtual void write(const byte input[], size_t length)=0
Botan::MemoryRegion::clear
void clear()
Definition: secmem.h:152
Botan::MemoryRegion::size
size_t size() const
Definition: secmem.h:29

## ◆ send() [2/4]

void Botan::Filter::send | ( | byte | in | ) |
| inlineprotectedinherited

Parameters

  in | some input for the filter

Definition at line 63 of file filter.h.

References Botan::Filter::send().

Referenced by Botan::Filter::send().

63 { send(&in, 1); }
Botan::Filter::send
void send(const byte in[], size_t length)
Definition: filter.cpp:28

## ◆ send() [3/4]

void Botan::Filter::send | ( | const MemoryRegion< byte > & | in | ) |
| inlineprotectedinherited

Parameters

  in | some input for the filter

Definition at line 68 of file filter.h.

References Botan::Filter::send(), and Botan::MemoryRegion< T >::size().

Referenced by Botan::Filter::send().

68 { send(&in[0], in.size()); }
Botan::Filter::send
void send(const byte in[], size_t length)
Definition: filter.cpp:28
Botan::MemoryRegion::size
size_t size() const
Definition: secmem.h:29

## ◆ send() [4/4]

void Botan::Filter::send | ( | const MemoryRegion< byte > & | in,
|  | size_t | length
| ) |  |
| inlineprotectedinherited

Parameters

  in | some input for the filter
  length | the number of bytes of in to send

Definition at line 74 of file filter.h.

75 {
76 send(&in[0], length);
77 }
Botan::Filter::send
void send(const byte in[], size_t length)
Definition: filter.cpp:28

## ◆ start_msg()

virtual void Botan::Filter::start_msg | ( |  | ) |
| inlinevirtualinherited

Start a new message. Must be closed by end_msg() before another message can be started.

Reimplemented in Botan::Zlib_Decompression, Botan::EAX_Base, Botan::Bzip_Decompression, Botan::PBE_PKCS5v20, Botan::PBE_PKCS5v15, Botan::Bzip_Compression, and Botan::Zlib_Compression.

Definition at line 38 of file filter.h.

Referenced by Botan::Filter::send().

38 {}

## ◆ write()

void Botan::Hash_Filter::write | ( | const byte | input[],
|  | size_t | length
| ) |  |
| inlinevirtual

Write a portion of a message to this filter.

Parameters

  input | the input as a byte array
  length | the length of the byte array input

Implements Botan::Filter.

Definition at line 107 of file filters.h.

107 { hash->update(input, len); }
Botan::Buffered_Computation::update
void update(const byte in[], size_t length)
Definition: buf_comp.h:33

The documentation for this class was generated from the following files:

- src/filters/filters.h
- src/filters/algo_filt.cpp